const fetch = require('isomorphic-fetch')

// Fetch the content of a given subreddit
module.exports = {
  args: ['subreddit', 'count?'],
  fn: (subreddit, count) => {
    if (!subreddit) throw { message: 'No subreddit given', status: 404 }
    return fetch(`http://reddit.com/r/${subreddit}.json`)
      .then(res => res.json())
      .then(json => {
        if (json.error) throw { message: json.message, status: json.error }
        return json
      })
      .then(json => json.data.children)
      .then(items => items.slice(0, count || items.length))
      .then(items => items
        .map(item => item.data)
        .map(({ id, title, url, selftext, created, edited }) => ({
          id,
          title,
          url,
          text: selftext,
          dates: { created, edited }
        }))
      )
  }
}
